
' -------------------------------------------------------------------------
' Main EXIF reader...
' -------------------------------------------------------------------------

Function PrintEXIFInfo (jpeg:TStream, tiffsize:Int)

	' --------------------------------------------------------------------
	' Local EXIF image file directory parser...
	' --------------------------------------------------------------------

	' This will loop through the Image File Directory entries, loop through the tag directories
	' within each, and recursively loop into offset IFDs...
	
	Local params:ParameterBundle = New ParameterBundle

	params.jpeg			= jpeg
	
	params.tiffstart	= StreamPos (params.jpeg)
	params.tiffend		= (params.tiffstart + tiffsize) - 1
	
	' -----------------------------------------------------------------
	' TIFF header...
	' -----------------------------------------------------------------

	Select ReadShort (params.jpeg)
	
		Case $4D4D ' Motorola byte format ("MM")
		
			ReadShort (params.jpeg)
'				If ReadShort (params.jpeg) = $002A Then TabPrint "[EXIF section's TIFF header in MOTOROLA byte format]"
			params.endian = ENDIAN_MOTOROLA
			
		Case $4949 ' Intel byte format ("II")
		
			ReadShort (params.jpeg)
'				If ReadShort (params.jpeg) = $2A00 Then TabPrint "[EXIF section's TIFF header in INTEL byte format]"
			params.endian = ENDIAN_INTEL

		Default

			' Prolly won't happen...
			
			Print "[EXIF section's TIFF header in UNDEFINED byte format...]"
			Notify "Undefined byte format... I'm outta here!", True
			End
			
	End Select
	
	params.ifdoffset = ReadInt (params.jpeg)
	
	If params.endian = ENDIAN_INTEL Then params.ifdoffset = SwapEndianInt (params.ifdoffset)
	
	SeekStream params.jpeg, params.tiffstart + params.ifdoffset ' Almost always 8, but I found at least one image that was different!

'		Print "IFDOFFSET Seeked to " + StreamPos (params.jpeg)
	
	' -----------------------------------------------------------------
	' Begin with Primary Image Data IFD...
	' -----------------------------------------------------------------

	' Create/clear global list to record IFD offsets visited (prevents infinite loops
	' with broken circular-referencing files)...
	
	IFDsVisited = CreateList ()

	ParseIFD params

	params = Null
	
End Function

