
' Byte-endianness...

Const ENDIAN_MOTOROLA:Int = 0
Const ENDIAN_INTEL:Int = 1

' --------------------------------------------------------------------
' Bundle of frequently-passed parameters among these functions...
' --------------------------------------------------------------------

Type ParameterBundle

	' JPEG's EXIF data is actually stored in an embedded TIFF file...
	
	Field jpeg:TStream			' File
	
	Field tiffstart:Int			' TIFF 'file' start
	Field tiffend:Int			' Last byte of TIFF 'file'
	
	Field ifdoffset:Int			' Next IFD offset
	
	Field tag:Short				' Data tag
	Field value:Int				' Tag value
	Field endian:Int			' Byte order
	Field components:Int		' Data components
	Field dataformat:Short		' Data format
	Field tagpos:Int			' Tag position in file
	
	Field level:Int ' For TabPrint -- indents based on level of recursion
	
End Type

' Gah, where's Monkey's BoxInt when you need it?

Type IFDOffset
	Field offset:Int
End Type

' Ugly hack to keep track of which file offsets have already been visited. Necessary
' as some EXIF data contains circular references that otherwise cause infinite loops...
	
Global IFDsVisited:TList
