
Function PrintJPEGInfo (f:String, singleframe:Int = False)

	Print ""
	Print "Info for " + f
	
	Local jpeg:TStream = BigEndianStream (ReadFile (f))

	If jpeg

		Try

			' Start of Image (SOI) marker ($FFD8) -- MUST BE PRESENT!
			
			If ReadByte (jpeg) = $FF And ReadByte (jpeg) = $D8

			'	TabPrint ""
			'	TabPrint "--------------------------------------------------------------------------------"
			'	TabPrint "Start of Image marker $D8 found at byte offset 0"
			'	TabPrint "--------------------------------------------------------------------------------"
			'	TabPrint "Assuming JPEG file"
				
				Local loop:Int			' For byte seek loops...
				Local datalength:Int	' Block length store

				Local checkff:Byte		' Byte to be tested for $FF (start of block)...
				Local marker:Byte		' Block marker...

				Local startofblock:Int
				Local startofdata:Int
				Local blockbytesread:Int

				Local markerinfo:String
				Local scandata:Int
				
				Local printinfo:Int
				
				Local exifcount:Int
				Local alldone:Int
				
				While Not Eof (jpeg)
		
					' Searching for blocks beginning with $FF, then single byte marker, then data...
					
					' |FFxx|length_of_block|data_data_data...

					' |FFxx|length_of_block| is four bytes total, two each...
					
					' ---------------------------------------------------------
					' You are here --> |FFxx|length_of_block|data_data_data...
					' ---------------------------------------------------------
					
					startofblock = StreamPos (jpeg)
					
					' Looking for FF first...
					
					Repeat
						checkff = ReadByte (jpeg) ' Some Photoshop 7 files have a huge string of zeroes directly after block's stated data length
					Until checkff

					' Used later...
					
					startofdata = 0
					blockbytesread = 0
					datalength = 0
					markerinfo = ""
					
					If checkff = $FF
	
						' ... then xx, the byte AFTER the FF block marker, skipping if FF (padding)...
						
						Repeat
							marker = ReadByte (jpeg)
						Until marker <> $FF

						' -----------------------------------------------------
						' We are now here --> |length_of_block|data_data_data...
						' -----------------------------------------------------
						
						' Grab next two bytes (length of block) before proceeding, unless marker is standalone...

						Select marker
						
							Case $D0, $D1, $D2, $D3, $D4, $D5, $D6, $D7, $D8, $D9, $0, $FF
							
								' Standalone markers with no following data.
							
							Default

								datalength = ReadShort (jpeg) - 2 ' The 2 subtracted bytes store the length itself...
						
						End Select
						
						' -----------------------------------------------------
						' Now here --> |data_data_data...
						' -----------------------------------------------------
						
						' Record start of data so we can deduce how many bytes are read in each Case afterwards...

						startofdata = StreamPos (jpeg)
						
						scandata = False
						printinfo = False
						
						Select marker
							
							Case $0, $FF
							
								' Ignore these...

							Case $C0
							
								markerinfo = "Start of Frame (Huffman Baseline DCT)"

								printinfo = True

							Case $C1
							
								markerinfo = "Start of Frame (Huffman Extended Sequential DCT)"

								printinfo = True

							Case $C2
							
								markerinfo = "Start of Frame (Huffman Progressive DCT)"

								printinfo = True

							Case $C3
							
								markerinfo = "Start of Frame (Huffman Lossless Seqential)"

								printinfo = True

							Case $C4
							
								markerinfo = "Define Huffman Table"

							Case $C5
							
								markerinfo = "Start of Frame (Huffman Differential Sequential DCT)"

								printinfo = True

							Case $C6
							
								markerinfo = "Start of Frame (Huffman Differential Progressive DCT)"

								printinfo = True

							Case $C7
							
								markerinfo = "Start of Frame (Huffman Differential Lossless Sequential)"

								printinfo = True

							Case $C8
							
								markerinfo = "Start of Frame (Arithmetic, reserved for JPEG extensions)"

								printinfo = True

							Case $C9
							
								markerinfo = "Start of Frame (Arithmetic Extended Sequential DCT)"

								printinfo = True

							Case $CA
							
								markerinfo = "Start of Frame (Arithmetic Progressive DCT)"

								printinfo = True

							Case $CB
							
								markerinfo = "Start of Frame (Arithmetic Lossless Sequential)"

								printinfo = True

							Case $CC
							
								markerinfo = "Define Arithmetic Table"

							Case $CD
							
								markerinfo = "Start of Frame (Arithmetic Differential Sequential DCT)"

								printinfo = True

							Case $CE
							
								markerinfo = "Start of Frame (Arithmetic Differential Progressive DCT)"

								printinfo = True

							Case $CF
							
								markerinfo = "Start of Frame (Arithmetic Differential Lossless Sequential)"

								printinfo = True

							Case $D0, $D1, $D2, $D3, $D4, $D5, $D6, $D7
							
								markerinfo = "Restart"
								
								' Standalone marker, no following data...
								
							Case $D8
							
								markerinfo = "Start of Image"

								' Now going through scan (picture) data and ignoring it because it's bloody complicated...
							
								Local newff:Byte
								Local breakout:Int = False
								
								Local startdatascan:Int = StreamPos (jpeg)
								
								Repeat
								
									' Got a $FF value?
									
									If ReadByte (jpeg) = $FF

										' See if it's a new block marker...
										
										newff = ReadByte (jpeg)
										
										If (newff <> 0) And (newff <> $FF) ' Ignore 0/FF (possible valid/padding data)...
											breakout = True
										EndIf
									
									EndIf
									
								Until breakout
								
								' Special case... $D8 can appear multiple times per JPEG file, not just at the end. (Multiple images.)
								
								If newff = $D9
									If Eof (jpeg)
										alldone = True
									EndIf
								EndIf

								Local scanlength:Int = StreamPos (jpeg) - startdatascan
								
								' Add scan data to datalength...
								
								datalength = (datalength + scanlength) - 2 ' We need to go back two previously read bytes so they can be parsed...
								
							Case $D9
							
								'Print "D9"
							
								markerinfo = "End of Image"
								
								'TabPrint "EOI"

								' Now going through scan (picture) data and ignoring it because it's bloody complicated...
							
								Local newff:Byte
								Local breakout:Int = False
								
								Local startdatascan:Int = StreamPos (jpeg)
								
								Repeat
								

								'TabPrint "SP: " + StreamPos (jpeg)
								
									' Got a $FF value?
									
									If Eof (jpeg) Then breakout = True'; Print "EOF!"
									
									If ReadByte (jpeg) = $FF

										' See if it's a new block marker...
										
										newff = ReadByte (jpeg)
										
										'Print Hex (newff)
										
										' Value after $FF marker is 0 or $FF, both valid padding data, so keep reading,
										' otherwise, break out of loop:
										
										If (newff <> 0) And (newff <> $FF) ' Ignore 0/FF (possible valid/padding data)...
											breakout = True
										EndIf
																		
									EndIf
								
								Until breakout
								
								' Special case... $D9 can appear multiple times per JPEG file, not just at the end. (Multiple images.)
								
								If newff = $D9
									'Print StreamPos (jpeg)
									If Eof (jpeg)
										'Print "ALLDONE"'; End
										alldone = True
									EndIf
								EndIf
								
								Local scanlength:Int = StreamPos (jpeg) - startdatascan
								
								' Add scan data to datalength...
								
								datalength = (datalength + scanlength) - 2 ' We need to go back two previously read bytes so they can be parsed...
								
								' Standalone marker, no following data...
								
							Case $DA
							
								markerinfo = "Start of Scan"
								
								'TabPrint "START OF SCAN DATA"
								
								For loop = 0 Until ReadByte (jpeg) ' Components
									ReadByte jpeg ' Component ID
									ReadByte jpeg ' Huffman table (bits 0-3: AC table; bits 4-7: DC table)
								Next
								
								' Ignore these three bytes...
								
								ReadByte (jpeg)
								ReadByte (jpeg)
								ReadByte (jpeg)

								' Now going through scan (picture) data and ignoring it because it's bloody complicated...
							
								Local newff:Byte
								Local breakout:Int = False
								
								Local startdatascan:Int = StreamPos (jpeg)
								
								Repeat
								
									' Got a $FF value?
									
									If ReadByte (jpeg) = $FF

										' See if it's a new block marker...
										
										newff = ReadByte (jpeg)
										
										Select newff
									
											' Ignore 0 (means valid FF value in scan data), FF (possible padding data), D0-D7 (restart markers)...
											
											Case $0, $FF, $D0, $D1, $D2, $D3, $D4, $D5, $D6, $D7

												' Ignore these and move on...
												
											' Anything else? Must be a valid block marker, in theory...
											
											Case $D9
												'TabPrint "D9"
												breakout = True
												
											Default
											
												breakout = True
									
										End Select
									
									EndIf
									
								Until breakout
								
								' Special case... $D9 can appear multiple times per JPEG file, not just at end! (Multiple images.)
								
								If newff = $D9
									'TabPrint "D9 END"
									If Eof (jpeg)
										alldone = True
									EndIf
								EndIf
								
								'Print "EOS " + StreamPos (jpeg)
								
								Local scanlength:Int = StreamPos (jpeg) - startdatascan
								
								' Consider scan data to be part of datalength...
								
								datalength = (datalength + scanlength) - 2 ' We need to go back two previously read bytes so they can be parsed...
								
							Case $DB
							
								markerinfo = "Define Quantization Table"
							
							Case $DC
							
								markerinfo = "Define Number of Lines"

							Case $DD
							
								markerinfo = "Define Restart Interval"
								
							Case $DE
							
								markerinfo = "Define Hierarchical Progression"
							
							Case $DF
							
								markerinfo = "Expand reference components"
							
							Case $E0 ' JFIF marker
						
								markerinfo = "JFIF/APP0"
								
								' Check for JFIF identification string (generally treated as optional)...
								
								ReadString jpeg, 5
								
								' Or...
								
'								If ReadString (jpeg, 5) = "JFIF" + Chr (0)
									'TabPrint "Valid JFIF file"
'								Else
									'TabPrint "Not a valid JFIF file"
'								EndIf

							Case $E1 ' EXIF information
							
								markerinfo = "EXIF"

								' Only parse if Exif00 is here. Apparently other apps can insert data using
								' this tag, which will cause reader to fail if it's not EXIF data...
								
'								TabPrint "EXIF data starts at byte offset " + startofdata + " and is " + datalength + " bytes long"
								
								If ReadString (jpeg, 6) = "Exif" + Chr (0) + Chr (0)
									PrintEXIFInfo jpeg, datalength - 6 ' Length of TIFF data containing EXIF information!
									exifcount = exifcount + 1
								EndIf
								
								' Exit ' Early-out if we only need first lot of EXIF data...
					
							Case $E2, $E3, $E4, $E5, $E6, $E7, $E8, $E9, $EA, $EB, $EC, $EE, $EF
								
								markerinfo = "Unimplemented, application-specific"
							
							Case $ED
							
								markerinfo = "Photoshop/APP14"

							Case $FE
							
								markerinfo = "Comment"
								
							Default
								
								markerinfo = "UNIMPLEMENTED"
								
						End Select

'						TabPrint ""
'						TabPrint "--------------------------------------------------------------------------------"
'						TabPrint markerinfo + " marker $" + Right (Hex (marker), 2) + " found at byte offset " + startofblock
'						TabPrint "--------------------------------------------------------------------------------"
						
				'		If datalength
				'			TabPrint "Data starts at byte offset " + startofdata + " and is " + datalength + " bytes long"
				'		Else
				'			TabPrint "No data for this type of marker"
				'		EndIf
						
				'		If printinfo
							'PrintImageData jpeg ' Got a $Cx marker so print info!
							' Exit ' Only wanted information for main image, don't need EXIF? Just uncomment this!
				'		EndIf

					Else
						' Invalid marker offset, so skip rest of file for safety...
						'TabPrint "BOOM! INVALID MARKER: " + Hex (checkff) + " -- skipping rest of file!"
						Exit
'						End
					EndIf

					If alldone
					
						'TabPrint ""
						'TabPrint "--------------------------------------------------------------------------------"
						'TabPrint "End of Image marker $D9 found at end of file -- all done!"
						'TabPrint "--------------------------------------------------------------------------------"
						'TabPrint ""

					Else
					
						' Number of bytes already read in this block...
							
						blockbytesread = StreamPos (jpeg) - startofdata
	
						' Go to next block...

						SeekStream jpeg, StreamPos (jpeg) + (datalength - blockbytesread)
						'Print "NEXTBLOCK Seeked to " + StreamPos (jpeg)
						
					EndIf
					
				Wend
		
				If exifcount = 0 Then Print "No EXIF data in file."

			EndIf

			Catch ReadFail:Object
			Print "Read error in " + f + "; " + StreamPos (jpeg)

		End Try
		
		CloseFile jpeg
	
	Else
		TabPrint "File not found!"
	EndIf

End Function
