
Function TagName:String (tag:Int)

	Select tag
	
		' -----------------------------------------------------
		' IFD0/1 values...
		' -----------------------------------------------------
		
		Case $0100
			Return "ImageWidth"
		Case $0101
			Return "ImageLength"
		Case $0102
			Return "BitsPerSample"
		Case $0103
			Return "Compression"
		Case $0106
			Return "PhotometricInterpretation"
		Case $010E
			Return "ImageDescription"
		Case $010F
			Return "Make"
		Case $0110
			Return "Model"
		Case $0111
			Return "StripOffsets"
		Case $0112
			Return "Orientation"
		Case $0115
			Return "SamplesPerPixel"
		Case $0116
			Return "RowsPerStrip"
		Case $0117
			Return "StripByteCounts"
		Case $011A
			Return "XResolution"
		Case $011B
			Return "YResolution"
		Case $011C
			Return "PlanarConfiguration"
		Case $0128
			Return "ResolutionUnit"
		Case $012D
			Return "TransferFunction"
		Case $0131
			Return "Software"
		Case $0132
			Return "DateTime"
		Case $013B
			Return "Artist"
		Case $013E
			Return "WhitePoint"
		Case $013F
			Return "PrimaryChromaticities"
		Case $0201
			Return "JPEGInterchangeFormat"
		Case $0202
			Return "JPEGInterchangeFormatLength"
		Case $0211
			Return "YCbCrCoefficients"
		Case $0212
			Return "YCbCrSubSampling"
		Case $0213
			Return "YCbCrPositioning"
		Case $0214
			Return "ReferenceBlackWhite"
		Case $8298
			Return "Copyright"
			
		' -----------------------------------------------------
		' EXIF Sub-IFD values...
		' -----------------------------------------------------
		
		Case $0000829A
			Return "ExposureTime"
		Case $0000829D
			Return "FNumber"
		Case $00008822
			Return "ExposureProgram"
		Case $00008824
			Return "SpectralSensitivity"
		Case $00008827
			Return "ISOSpeedRatings"
		Case $00008828
			Return "OECF"
		Case $00009000
			Return "ExifVersion"
		Case $00009003
			Return "DateTimeOriginal"
		Case $00009004
			Return "DateTimeDigitized"
		Case $00009101
			Return "ComponentsConfiguration"
		Case $00009102
			Return "CompressedBitsPerPixel"
		Case $00009201
			Return "ShutterSpeedValue"
		Case $00009202
			Return "ApertureValue"
		Case $00009203
			Return "BrightnessValue"
		Case $00009204
			Return "ExposureBiasValue"
		Case $00009205
			Return "MaxApertureValue"
		Case $00009206
			Return "SubjectDistance"
		Case $00009207
			Return "MeteringMode"
		Case $00009208
			Return "LightSource"
		Case $00009209
			Return "Flash"
		Case $0000920A
			Return "FocalLength"
		Case $00009214
			Return "SubjectArea"
		Case $0000927C
			Return "MakerNote"
		Case $00009286
			Return "UserComment"
		Case $00009290
			Return "SubSecTime"
		Case $00009291
			Return "SubSecTimeOriginal"
		Case $00009292
			Return "SubSecTimeDigitized"
		Case $0000A000
			Return "FlashPixVersion"
		Case $0000A001
			Return "ColorSpace"
		Case $0000A002
			Return "ExifImageWidth"
		Case $0000A003
			Return "ExifImageHeight"
		Case $0000A004
			Return "RelatedSoundFile"
		Case $0000A20B
			Return "FlashEnergy"
		Case $0000A20C
			Return "SpatialFrequencyResponse"
		Case $0000A20E
			Return "FocalPlaneXResolution"
		Case $0000A20F
			Return "FocalPlaneYResolution"
		Case $0000A210
			Return "FocalPlaneResolutionUnit"
		Case $0000A214
			Return "SubjectLocation"
		Case $0000A215
			Return "ExposureIndex"
		Case $0000A217
			Return "SensingMethod"
		Case $0000A300
			Return "FileSource"
		Case $0000A301
			Return "SceneType"
		Case $0000A302
			Return "CFAPattern"
		Case $0000A401
			Return "CustomRendered"
		Case $0000A402
			Return "ExposureMode"
		Case $0000A403
			Return "WhiteBalance"
		Case $0000A404
			Return "DigitalZoomRatio"
		Case $0000A405
			Return "FocalLengthIn35mmFilm"
		Case $0000A406
			Return "SceneCaptureType"
		Case $0000A407
			Return "GainControl"
		Case $0000A408
			Return "Contrast"
		Case $0000A409
			Return "Saturation"
		Case $0000A40A
			Return "Sharpness"
		Case $0000A40B
			Return "DeviceSettingDescription"
		Case $0000A40C
			Return "SubjectDistanceRange"
		Case $0000A420
			Return "ImageUniqueID"
	
		' -----------------------------------------------------
		' GPS sub-IFD values...
		' -----------------------------------------------------
	
		Case $0
			Return "GPSVersionID"
		Case $1
			Return "GPSLatitudeRef"
		Case $2
			Return "GPSLatitude"
		Case $3
			Return "GPSLongitudeRef"
		Case $4
			Return "GPSLongitude"
		Case $5
			Return "GPSAltitudeRef"
		Case $6
			Return "GPSAltitude"
		Case $7
			Return "GPSTimeStamp"
		Case $8
			Return "GPSSatellites"
		Case $9
			Return "GPSStatus"
		Case $A
			Return "GPSMeasureMode"
		Case $B
			Return "GPSDOP"
		Case $C
			Return "GPSSpeedRef"
		Case $D
			Return "GPSSpeed"
		Case $E
			Return "GPSTrackRef"
		Case $F
			Return "GPSTrack"
		Case $10
			Return "GPSImgDirectionRef"
		Case $11
			Return "GPSImgDirection"
		Case $12
			Return "GPSMapDatum"
		Case $13
			Return "GPSDestLatitudeRef"
		Case $14
			Return "GPSDestLatitude"
		Case $15
			Return "GPSDestLongitudeRef"
		Case $16
			Return "GPSDestLongitude"
		Case $17
			Return "GPSDestBearingRef"
		Case $18
			Return "GPSDestBearing"
		Case $19
			Return "GPSDestDistanceRef"
		Case $1A
			Return "GPSDestDistance"
		Case $1B
			Return "GPSProcessingMethod"
		Case $1C
			Return "GPSAreaInformation"
		Case $1D
			Return "GPSDateStamp"
		Case $1E
			Return "GPSDifferential"
		
	End Select

End Function
